﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		private var tableau:Array;
		private var forme:Number;

		
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			//setup();
		}
		
		
		private function setup1():void
		{
			max			= 100;
			fibonacci	= 2/1.988033989;
			accident	= .998;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function setup2():void
		{
			max			= 70;
			fibonacci	= 2/0.988033989;
			accident	= .508;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 3.001;
			rpy			= 5.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function setup3():void
		{
			max			= 150;
			fibonacci	= 2/9.988033989;
			accident	= .508;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function setup4():void
		{
			max			= 200;
			fibonacci	= 2/19.988033989;
			accident	= .508;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function setup5():void
		{
			max			= 61;
			fibonacci	= 2/8.988033989;
			accident	= .508;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function setup():void
		{
			max			= 200;
			fibonacci	= 2/40.988033989;
			accident	= .508;
			rapport 	= 200-360*fibonacci - 5;
			rad 		= 50;
			growth		= 1.008;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.030;
		
			cur			= max;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			
			//setup();
			//removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			//graphics.clear();
			forme = Math.round(Math.random()*5);

			if(forme==0){
				setup1();
			}
			if(forme==1){
				setup2();
			}
			if(forme==2){
				setup3();
			}
			if(forme==3){
				setup4();
			}
			if(forme==4){
				setup5();
			}
			if(forme==5){
				setup();
			}
			
			
			addEventListener(Event.ENTER_FRAME, enterhandler);
			
			tableau = new Array();
			var pt= new Point(e.stageX,e.stageY);
			tableau.push({"positionx":this.globalToLocal(pt).x,"positiony":this.globalToLocal(pt).y});
			trace(tableau[0].positionx,tableau[0].positiony)
			trace(fibonacci);
			trace(forme);
		}
		
		private function moveHandler(e:MouseEvent):void
		{
			var pt= new Point(e.stageX,e.stageY);
			tableau.push({"positionx":this.globalToLocal(pt).x,"positiony":this.globalToLocal(pt).y});
			//tableau.push({"positionx":e.stageX,"positiony":e.stageY});
		}
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				//rapport*=accident;
				sc_x*=rpx;
				sc_y*=rpy;
				rot += rapport;
				rot-= new int(rot/360)*360;
				rad*=growth;
				var x:Number = tableau[0].positionx+Math.cos(rot * Math.PI/180) *rad;
				var y:Number = tableau[0].positiony+Math.sin(rot * Math.PI/180) *rad;
				if(cur!= (max-1)){
					if(forme==0){
						graphics.lineStyle(1.5,0xdd8a1e,.2);
					}
					if(forme==1){
						graphics.lineStyle(1.5,0x2ab0dd,.2);
					}
					if(forme==2){
						graphics.lineStyle(1.5,0xaeddbd,.2);
					}
					if(forme==3){
						graphics.lineStyle(1.5,0xc40035,.2);
					}
					if(forme==4){
						graphics.lineStyle(1.5,0x0066ff,.2);
					}
					if(forme==5){
						graphics.lineStyle(1.5,0x009900,.2);
					}
					graphics.lineTo(x,y);
				}else{
					graphics.moveTo(x,y);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}